package jalview.bin.argparser;

/**
 * A helper class to keep an index of argument position with argument values
 */
public class ArgValue
{
  private int argIndex;

  private String value;

  private String id;

  private SubVals subVals = null;

  protected ArgValue(SubVals sv, String content, int argIndex)
  {
    this.value = content;
    this.argIndex = argIndex;
    this.subVals = sv;
  }

  protected ArgValue(String value, int argIndex)
  {
    this.argIndex = argIndex;
    this.subVals = ArgParser.getSubVals(value);
    this.value = getSubVals().getContent();
  }

  public String getValue()
  {
    return value;
  }

  public int getArgIndex()
  {
    return argIndex;
  }

  protected void setId(String i)
  {
    id = i;
  }

  public String getId()
  {
    return id;
  }

  public SubVals getSubVals()
  {
    return subVals;
  }

  public String getSubVal(String key)
  {
    if (subVals == null || !subVals.has(key))
      return null;
    return subVals.get(key);
  }

  protected void putSubVal(String key, String val)
  {
    this.subVals.put(key, val);
  }
}